<?php

/*  thread_view.php: View a single message thread
*
    Copyright (C) 2002  Hastymail Development group

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; Version 2
    See the COPYING file for complete information.

* $Id: thread_view.php,v 1.42 2003/10/06 04:30:21 sailfrog Exp $
*/

require_once('../lib/wrapper_functions.php');

/* collect and validate incoming vars */
$hm_input = hm_validate_input($_POST, $_GET, 'thread_view');

/* set ini values and check/get the SESSION vars */
if (hm_session_continue($hm_input['id'], $config_file)) {
    $config = $_SESSION['config'];
}
$hm_input['id'] = session_id();
$str = $_SESSION['str'];

/* login to imap */
if (!$imap_stream = hm_imap_login($_SESSION['user'], $_SESSION['pass'], $config,
                                  $hasty_key, false, false)) {
    hm_logged_out($config_file);
}

/* get unseen status */
$unseen = hm_unseen_status($imap_stream, $_SESSION['folders']);

/* select the mailbox for imap */
hm_select_mailbox($imap_stream, $hm_input['mailbox']);

/* sort information */

$cache = false;
if (isset($_SESSION['thread_data'][$hm_input['mailbox']]) && 
    !isset($hm_input['update'])) {
    foreach ($_SESSION['thread_data'][$hm_input['mailbox']] as $index => $array) {
        if (in_array($hm_input['uid'], $array[1])) {
            $sort_info = $array;
            $cache = true;
            break;
        }
    }
}
if (!$cache) {
    $sort_info = hmw_get_sort_info($imap_stream, 'THREAD_R', 
                                  $hm_input['mailbox'], $hm_input['uid']);
}

/* toolbar */
hm_toolbar($imap_stream, $hm_input['mailbox'], $unseen, false, $str[173]);

$thread_count = count($sort_info[1]);

/* create ordered list of message indent */
$ref = array();
foreach ($sort_info[1] as $index => $message) {
    $ref[] = $sort_info[0][$message];
}

$headers = hm_get_messages (implode(',', $sort_info[1]), $imap_stream);
$start = true;
$row = 0;
foreach ($sort_info[1] as $uid) {
    $array = $headers[$uid];
    if ($start) {
        echo '<br>
<table width="95%" align="center" cellpadding="1" cellspacing="0" class="tables5">',"\n";
if ($cache) {
echo '   <tr>
      <td colspan="3" nowrap>
      <form action="thread_view.php" method="post">
      <table align="center" cellpadding="4" cellspacing="1" class="tables1">
         <tr>
            <td>
            <small>
            &nbsp;&nbsp;&nbsp;',$str[172],'.&nbsp;&nbsp;&nbsp;
            &nbsp;&nbsp;
            </td>
            <td>
            <input type="hidden" name="id" value="',$hm_input['id'],'">
            <input type="hidden" name="mailbox" value="',$hm_input['mailbox'],'">
            <input type="hidden" name="uid" value="',$hm_input['uid'],'">
            <input type="submit" class="button2" name="update" value="',$str[61],'">
            </small>
            </td>
         </tr>
      </table>
      </form>
      <br>
      </td>
   </tr>',"\n";
}
echo '   <tr>
      <td colspan="3" nowrap align="center">
      <table align="center" width="99%" cellpadding="4" cellspacing="2" class="tables1">
         <tr>
            <td>
            <small>',$str[171],':&nbsp;&nbsp;</small>
            <a class="font2" href="mailbox.php?mailbox=',$hm_input['mailbox'],
            '&amp;id=',urlencode($hm_input['id']),'">',urldecode($hm_input['mailbox']),'
            </a>
            </td>
            <td>
            <small>&nbsp;&nbsp;<b>',$thread_count,
            '</b>',$str[214],':</small>
            &nbsp;&nbsp;&nbsp;<font class="font1">',$array[0],'
            </font>
            </td>
         </tr>
      </table>
      <br>
      </td>
   </tr>
   <tr class="tables0">
      <td align="center">
      <small>
      ',$str[21],':
      </small>
      </td>
      <td align="center">
      <small>
      ',$str[22],':
      </small>
      </td>
      <td align="center">
      <small>
      ',$str[23],':
      </small>
      </td>
   </tr>',"\n";
        $start = false;
    }
    /* check content for charset conversion */
        $cont_charset = false;
        $charset_convert = false;
        $code_page = false;
        if (isset($headers[$uid][4]) &&
            $cont_charset = strstr(strtolower($headers[$uid][4]), 'charset')) {
            if ($str['charset'] == 'UTF-8') {
                $cont_charset = substr(strstr($cont_charset, '='), 1);
                $cont_charset = substr($cont_charset, 0, strcspn($cont_charset, ' '));
                $cont_charset = str_replace(array('"', ';'), '', $cont_charset);
                $cont_charset = trim($cont_charset);
                if (isset($_SESSION['charsets'][$cont_charset])) {
                    $code_page = $_SESSION['charsets'][$cont_charset];
                    $charset_convert = true;
                }
            }
        }
        /* set defaults for unset fields */
        /* subject */
        if (!isset($headers[$uid][0]) ||
            trim($headers[$uid][0]) == '') {
            $subject = $str[229];
        }
        else {
            $subject = $headers[$uid][0];
        }
        /* from */
        if (!isset($headers[$uid][1]) ||
            trim($headers[$uid][1]) == '') {
            $from = $str[230];
        }
        else {
            $from = ltrim(str_replace('&quot;', '', $headers[$uid][1]));
            if (substr($from, 0, 4) != '&lt;') {
                $from = preg_replace("/&lt;.*&gt;/", '', $from);
            }
            else {
                $from = str_replace(array('&lt;', '&gt;'), '', $from);
            }
        }
        /* date */
        if (!isset($headers[$uid][2]) ||
            trim($headers[$uid][2]) == '') {
            $date = $str[231];
        }
        else {
            $date = $headers[$uid][2];
        }
        /* content type */
        if (isset($headers[$uid][4])) {
            $content = $headers[$uid][4];
        }
        else {
            $content = '';
        }
        /* flags */
        if (isset($headers[$uid][5])) {
            $flags = $headers[$uid][5];
        }
        else {
            $flags = '';
        }
        /* unseen status */
        if (!stristr($flags, 'seen')) {
            $new = 1;
            $class = 'tables6';
            $font = 'font2';
        }
        else {
            $new = 0;
            $class = 'tables2';
            $font = 'font1';
        }
        /* size */
        if (isset($headers[$uid][7])) {
            $size = $headers[$uid][7];
        }
        else {
            $size = '';
        }
    echo '   <tr class="',$class,'">
      <td width="50%">
      <table width="100%" cellpadding="0" cellspacing="0">
         <tr>
            <td width="1%" nowrap valign="top" >',"\n";
    if ($hm_input['uid'] == $uid) {
        echo "            <small><b>-&gt</b></small>\n";
    }
    else {
        echo "            <small><b>&nbsp;&nbsp;&nbsp;</b></small>\n";
    }

    if (!empty($sort_info[0]) && isset($sort_info[0][$uid])) {
        if ($sort_info[0][$uid] > 1) {
            $range = array_slice($ref, $row); 
            $remaining = $range;
            $place = array();
            foreach ($range as $index => $val) {
                if ($val < $sort_info[0][$uid]) {
                    $add = true;
                    foreach ($remaining as $v) {
                        if ($v == $val) {
                            $add = true;
                            break;
                        }
                        if ($v < $val) {
                            $add = false;
                            break;
                        }
                    }
                    if ($add) {
                        $place[] = $val;
                    }
                }
            }
            $string = str_repeat("_", $sort_info[0][$uid]);
            foreach ($place as $value) {
                $string{$value} = '|';
            }
            $string = str_replace('_', '&nbsp;&nbsp;', $string);
            $string = str_replace('|', '|&nbsp;&nbsp;', $string);
            echo "            <font class=\"font2\">$string|_</font>&nbsp;\n";
        }
        else {
            echo "               &nbsp;\n";
        }
    }
    echo '            </td>
            <td valign="top">
            <small><a class="',$font,'" href="message.php?mailbox=',
         urlencode($hm_input['mailbox']), '&amp;id=',
         urlencode($hm_input['id']),'&amp;uid=',$uid, '&amp;new=',$new,
         '&amp;thread=1">
            ',$subject,'
            </a></small>
            </td>
         </tr>
      </table>
      </td>
      <td width="30%" valign="top">
      <small><a class="',$font,'" href="message.php?mailbox=',
      urlencode($hm_input['mailbox']),'&amp;id=',urlencode($hm_input['id']),
      '&amp;uid=',$uid,'&amp;new=',$new,'&amp;thread=1';
    if (strlen($from) > 41) {
        echo '" title="',trim($from),'">',substr($from, 0, 40),'...';
    }
    else {    
        echo '">
      ',trim($from);
    }
    echo "\n",'      </a></small>
      </td>
      <td width="15%" valign="top" nowrap>
      <small><a class="',$font,'" href="message.php?mailbox=',
      urlencode($hm_input['mailbox']),'&amp;id=',urlencode($hm_input['id']),
      '&amp;uid=',$uid,'&amp;new=',$new,'&amp;thread=1">
      ',htmlspecialchars($date, ENT_QUOTES, $str['charset']),'
      </a></small>
      </td>
   </tr>',"\n";
    $row++;
}
echo '</table>
</body>
</html>';

hm_imap_logout($imap_stream); 

?>
